
%% TF cluster test - step1
whichDAT = ''; % 'CSD','DSS',''

do_level1 = 1;
do_level2 = 1;

conditions = [1 3];

latencies =  'all';%

testchannel = 'all'; %'all'; % 'all'

alpha = 0.05;
clusthresh = 0.05;


sbs = dir([rawDir '*.cnt']);

%% prepare dummy data structure
if 1
DUMMY = cell(size(CORR_IND,1),3); % sbs x conditions x HFs

for i_sb = 1:size(CORR_IND,1)
    
    % determine number of trials per condition and randomly
    % select such that all conds have same N
    for i_cond= 1:3
        % ntrials(i_cond) = size(CORR_MAT_index{i_sb,i_cond},1);
        ntrials(i_cond) = size(CORR_IND{i_sb,i_cond},1);
    end
    min_trials = min(ntrials);

    clear DATA
    
    % load DATA for each SB to put in the TRF
    [dum SB] =  fileparts(sbs(i_sb).name);
    disp(['loading subject ' SB '...']);
    load([preprocDir filesep SB 'preproc_complete_' lock 'lock_HP_minphase']);
    
    DATA = DATA_clean; clear DATA_clean;
    
    for i_cond = 1:3
            clear condDATA
            
            trial_vec = sort(randsample([1:ntrials(i_cond)],min_trials));
            
            % cut the relevant time segment
            cfg = [];
            cfg.latency = [0];
            cfg.trials = 1:size(trial_vec,2);
            condDATA = ft_selectdata(cfg,DATA);
            
            condDATA.trialinfo = [];

            for i_trial = 1:size(condDATA.trial,2)
                tmpdat = CORR_IND{i_sb,i_cond}(trial_vec(i_trial),:);
                condDATA.trial{i_trial} = tmpdat';
                condDATA.time{i_trial} = 0; % with 1 timepoint, there is a bug in ft_selectdata
                clear tmpdat;
            end
            
            DUMMY{i_sb,i_cond} = condDATA;
            
        end

end
end

%% 1. level
if do_level1
    for i_sb = 1:size(sbs,1)
        contrastweights = [0.5 -0.5]; % condition values contrast
        % can set contrast weights with RT values to regress as well
        % whatever condition contrast weight values
        
        clear design
        
        design = cat(1, repmat(contrastweights(1) , size(DUMMY{i_sb,conditions(1)}.trial,2),1),...
            repmat(contrastweights(2) , size(DUMMY{i_sb,conditions(2)}.trial,2),1));
        design = design';
        
        
        cfg = [];
        % take all channels besides EOG and trigger channel
        
        cfg.method           = 'analytic'; % which type of statistics (bootstrapping)
        cfg.statistic        = 'ac_indepsamplesregrT';
        
        cfg.latency          = latencies;
        cfg.channel          =  testchannel;
        cfg.parameter        = 'trial';
        cfg.tail             = 0; % 2 tailed = 0;
        cfg.alpha            = alpha;
        cfg.trials           = 'all';
        cfg.correctm         = 'no';
        % cfg.reportbeta     ='no';
        cfg.feedback         ='gui';
        cfg.design           = design;
        cfg.ivar             = 1;
        cfg.cvar             = [];
        
        lev1_stats{i_sb,1} = ft_timelockstatistics(cfg, DUMMY{i_sb,conditions(1)},...
            DUMMY{i_sb,conditions(2)});
       
        
        %         figure(i_sb)
        %         subplot(2,1,1)
        %         ft_topoplotTFR(cfgp,lev1_stats{i_sb,1}); cbar;
        %         subplot(2,1,2)
        %         ft_singleplotTFR(cfgp,lev1_stats{i_sb,1}); cbar; hline(0);
    end
    
    % save ([statsDir filesep  'FirstLevel_' num2str(size(POW_cond,1)) '_' 'COND_' num2str(conditions(1)) '-' num2str(conditions(2))], 'lev1_stats');
end

%% 2.Level

if do_level2
    %     if ~do_level1
    %        load([statsDir filesep  'FirstLevel_' num2str(numel(sbs)) '_' 'COND_' num2str(conditions(1)) '-' num2str(conditions(2))]);
    %     end
    %% prepare_neighbours determines what sensors may form clusters
    % just do this once
    
    cfg_neighb                                =[];
    cfg_neighb.channel                = 'all'; %[1:28];
    cfg_neighb.layout                = 'easycapM11.mat';  %'EEG_electrodes.lay';
    cfg_neighb.neighbourdist = 0.175; %0.15 %= 4.7 negs; %0.2 = 7.9 avg neighbors / chan
    cfg_neighb.method                = 'distance';
    cfg_neighb.feedback                = 'no'; %'yes'; % ahve to do yes once
    
    
    %% 2nd level stats on TFS (all subjects)
    
    % clear lev1_stats
    
    % load lev1_stats from TFS
    % load([statsDir filesep  'FirstLevel_' num2str(numel(sbs)) '_' 'COND_2-1']);
    
    
    cfg=[];
    cfg.neighbours=  ft_prepare_neighbours(cfg_neighb,lev1_stats{1,1});
    
    %cfg = [];
    cfg.channel          = 'all'; %1:28;
    cfg.latency          = 'all';
    cfg.method           = 'montecarlo';
    cfg.statistic        = 'depsamplesT'; % within ss with fake data % or 'ft_statfun_depsamplesT' ??
    cfg.correctm         = 'cluster'; %
    cfg.clusteralpha     =  clusthresh ; % every time pt p < 0.05
    cfg.clusterstatistic = 'maxsum'; %sums overall t stats and test against bootstrapping dist
    cfg.minnbchan        = 3; % minimum channel cluster channels 3-10:
    cfg.tail             = 0;
    cfg.clustertail      = 0;
    cfg.alpha            = alpha;
    cfg.numrandomization = 1000;
    % cfg.correcttail = 'alpha';
    
    
    cfg.parameter         ='stat'; %'beta';
    
    subjects = size(DUMMY,1);
    %cfg.design=[ones(1,subjects) ones(1,subjects)*2; [1:subjects] [1:subjects]];
    cfg.design=[[1:subjects] [1:subjects];ones(1,subjects) ones(1,subjects)*2];
    
    cfg.ivar             = 2; %1;
    cfg.uvar             = 1; %2; % subj are units of observation (index in the data)
    
    clear zstats_help
    zstats_help=lev1_stats;
    for s=1:subjects;
        zstats_help{s,1}.stat(:,:,:) =0; % or take the dimension and put zeros
        %   lev1_stats{s,1}.stat(:,:,:)  = lev1_stats{s,1}.beta(:,:,:);
        zstats_help{s,1}.beta(:,:,:) =0;
    end
    
    clear lev2_stats_TRF
    lev2_stats_TRF = ft_timelockstatistics(cfg, lev1_stats{:}, zstats_help{:});
    
    %     save ([statsDir filesep  'SecondLevel_' num2str(size(SA_cond,1)) '_'...
    %         'COND_' num2str(conditions(1)) '-' num2str(conditions(2))], 'lev2_stats_TRF');
    %
end

%% plot mask
figure;
subplot(1,2,1)
imagesc(lev2_stats_TRF.time,1:size(lev2_stats_TRF.label,1),lev2_stats_TRF.stat,[-4 4]);
title('EEG II T');
colorbar;

subplot(1,2,2)
imagesc(lev2_stats_TRF.time,1:size(lev2_stats_TRF.label,1),lev2_stats_TRF.mask);
title('EEG II mask');
colorbar;


%% plot significant clusters
i_cluster =1;
pos_or_neg = 'pos';

% POS CLUSTER
lev2_stats_TRF.stat2 = lev2_stats_TRF.stat; % dummy

if strcmp(pos_or_neg,'pos')
    lev2_stats_TRF.stat2( lev2_stats_TRF.posclusterslabelmat~=i_cluster)=nan; % cluster #1 significant, others set to nan.
else
    lev2_stats_TRF.stat2( lev2_stats_TRF.negclusterslabelmat~=i_cluster)=nan; % cluster #1 significant, others set to nan.
end

% getting time, freq, chan in the pos cluster 1
time = find (~isnan(nanmean(lev2_stats_TRF.stat2)));
chan = find (~isnan(nanmean(lev2_stats_TRF.stat2,2)));

cfg = [];
cfg.xlim= [ lev2_stats_TRF.time(time(1)) lev2_stats_TRF.time(time(end))]%[2.4 3.5];

cfg.clustertimelim=cfg.xlim;
cfg.marker='off';
cfg.style='straight';
cfg.colorbar='yes';
cfg.comment='no';
% cfg.highlightsymbol= {'s'};
cfg.highlightsize= 2;
cfg.zparam='stat';
cfg.layout= 'easycapM11.mat'; %'elec1005.lay'
cfg.zlim = [-4 4];%'absmax';


cfg.highlight = 'on';
cfg.highlightchannel = lev2_stats_TRF.label(chan);
size(cfg.highlightchannel)

cfg.parameter = 'stat'; % if you set the parameter that has nan's, the topo looks weird, so just set to the original stat field.
figure; ft_topoplotER(cfg, lev2_stats_TRF)

if strcmp(pos_or_neg,'pos')
    title(['EEG II ERP: COND: ' num2str(conditions(1)) '-' num2str(conditions(2)),...
        '  time: ' num2str( lev2_stats_TRF.time(min(time))) '-'  num2str( lev2_stats_TRF.time(max(time))) 's',...
        ' p = ' num2str(lev2_stats_TRF.posclusters(i_cluster).prob)]);
    
else
    title(['EEG II ERP: COND: ' num2str(conditions(1)) '-' num2str(conditions(2)),...
        '  time: ' num2str( lev2_stats_TRF.time(min(time))) '-'  num2str( lev2_stats_TRF.time(max(time))) 's',...
        ' p = ' num2str(lev2_stats_TRF.negclusters(i_cluster).prob)]);
end

print('-dpdf',[PicDir filesep 'EEGII_TRF_Stats_CorrInd_CLUS', ...
    '.pdf'])% PicDir filesep

