%% Plot on Sourcelevel

% get data, e.g. TRFs
% must be a vector the size of the voxels

load([sourceDir filesep 'commonfilter_dummy.mat']);
load('standard_mri.mat');
close all


%%
clear activation
% lags and lambda for the TFR;
tau = [-200  600];
% timevector for the lags (used for plotting)
tlags = tau(1)/1000:1/200:tau(2)/1000;
t = nearest(tlags,[-0.01 0.01]);
% t = nearest(tlags,[0.2 0.3]);

%% plot GFP
figure(100);clf;
avg_activation = squeeze(nanmean(avgB_MAT,1));
for i_cond = 1:3
    for i_HF = 1 :2
        figure(100);
        GFP(i_cond,i_HF,:) = squeeze(std(avg_activation(i_cond,i_HF,:,:),[],3));
        plot(tlags,squeeze(GFP(i_cond,i_HF,:)));hold all;
        title('GFP')
    end
end

%%
close all
for i_cond =   3:-1:1 % for HF 2 looping backwards over conditions because thresholds are taken from 3
    for i_HF = 2% 1:2
       %%
       
        % extract activation for the conditions you want to plot
        % activation = squeeze(dat4topo(i_cond,i_HF,:));
        % for ITC over SBS
%         activation = ITC_MAT(i_cond,i_HF,:,t(1):t(2));
%         activation = squeeze(mean(activation,4));
        
        activation = squeeze(nanmean(avgB_MAT(:,i_cond,i_HF,:,t(1):t(2)),1));
        activation = squeeze(mean(activation,2));
        
        % put the activation vec. into the dummy source
        clear dummy_source
        dummy_source=commonfilter_tlock;
        dummy_source.avg.pow(dummy_source.inside) = activation;
        dummy_source.time= 0;
        
        % interpolate sources
        cfg              = [];
        cfg.parameter    = 'avg.pow';
        cfg.interpmethod = 'linear';
        source_intp = ft_sourceinterpolate(cfg, dummy_source, mri);
        
        % plotting parameters
        cfg              = [];
        cfg.method       = 'surface'; %'ortho'; 
        cfg.surffile = 'surface_white_right.mat';
        cfg.funparameter = 'pow';
        cfg.funcolormap    = 'parula';       
        cfg.renderer       = 'opengl';
        cfg.sphereradius = 40;        
        cfg.surfdownsample = 0;
        cfg.camlight='no';
        cfg.atlas = ft_read_atlas('/Users/sophie/ownCloud/MATLAB_Toolboxes/fieldtrip-20170501/template/atlas/aal/ROI_MNI_V4.nii');
        cfg.maskparameter  = cfg.funparameter;
        cfg.projmethod = 'project'; % nearest
        cfg.projvec = [5 5]; % setting this fixes the 'missing pixels'
        % cfg.projthresh = 0.70;
        
        if i_cond ==  3 % 3
        % are we looking at a positive or negative cluster? 
        if abs(max(activation)) > abs(min(activation))
            cfg.opacitymap     = 'rampup'; 
        elseif abs(max(activation)) < abs(min(activation))
            cfg.opacitymap     = 'rampdown'; 
        end
       
        if strcmp(cfg.opacitymap, 'rampdown')
            maxval = min(activation);
        elseif strcmp(cfg.opacitymap, 'rampup')
            maxval = max(activation);
        end
        opacitymap = cfg.opacitymap;
        else
        cfg.opacitymap = opacitymap;
        end
        
        % maxval = -0.015;
        
        cfg.funcolorlim    = [-(abs(maxval)) abs(maxval)];

        if maxval < 0 
        cfg.opacitylim     = [maxval maxval*0.7]; 
        elseif maxval > 0
        cfg.opacitylim     = [maxval*0.7 maxval];     
        end
      
        % for the negative peak lag 0
        % cfg.funcolorlim    = [-0.015 0.015];
        % cfg.opacitylim     = [-0.015 -0.015*0.7];
        
        % for the peak amplitudes
%         cfg.opacitymap     = 'rampup'; 
%         cfg.funcolorlim    = [-7 -6.3];
%         cfg.opacitylim     = [-6.5 -6.3];

        % plot
        cfg.title = (['COND: ' num2str(i_cond) '_HF: ' num2str(i_HF) '(maskval ' num2str(maxval*0.7) ')']);
        ft_sourceplot(cfg,source_intp);
        view([-1 0 0])
        lighting gouraud
       %  colorbar off
       
%%   
     print('-dpdf',[PicDir filesep 'CombMod_SOURCE_' ...,
         'COND_' num2str(i_cond), ...
         '_HF_' num2str(i_HF) '_lag0_right_med.pdf']); % _9HZpeak
   
    end
    
end


%% avg over conds
i_HF = 1;
        
         activation = squeeze(nanmean(avgB_MAT(:,:,i_HF,:,t(1):t(2)),1));
         activation = squeeze(mean(activation,1));
         activation = squeeze(mean(activation,2));
        
        % put the activation vec. into the dummy source
        clear dummy_source
        dummy_source=commonfilter_tlock;
        dummy_source.avg.pow(dummy_source.inside) = activation;
        dummy_source.time= 0;
        
        % interpolate sources
        cfg              = [];
        cfg.parameter    = 'avg.pow';
        cfg.interpmethod = 'linear';
        source_intp = ft_sourceinterpolate(cfg, dummy_source, mri);
        
        % plotting parameters
        cfg              = [];
        cfg.method       = 'surface'; %'ortho'; 
        cfg.surffile = 'surface_white_left.mat';
        cfg.funparameter = 'pow';
        cfg.funcolormap    = 'parula';       
        cfg.renderer       = 'opengl';
        cfg.sphereradius = 40;        
        cfg.surfdownsample = 0;
        cfg.camlight='no';
        cfg.atlas = ft_read_atlas('/Users/sophie/ownCloud/MATLAB_Toolboxes/fieldtrip-20170501/template/atlas/aal/ROI_MNI_V4.nii');
        cfg.maskparameter  = cfg.funparameter;
        cfg.projmethod = 'project'; % nearest
        cfg.projvec = [5 5]; % setting this fixes the 'missing pixels'
        % cfg.projthresh = 0.70;
        
        
        % are we looking at a positive or negative cluster? 
        if abs(max(activation)) > abs(min(activation))
            cfg.opacitymap     = 'rampup'; 
        elseif abs(max(activation)) < abs(min(activation))
            cfg.opacitymap     = 'rampdown'; 
        end
       
        if strcmp(cfg.opacitymap, 'rampdown')
            maxval = min(activation);
        elseif strcmp(cfg.opacitymap, 'rampup')
            maxval = max(activation);
        end
        
        % or set value by hand
        maxval = -0.015;
        
        cfg.funcolorlim    = [-(abs(maxval)) abs(maxval)];

        if maxval < 0 
        cfg.opacitylim     = [maxval maxval*0.8]; 
        elseif maxval > 0
        cfg.opacitylim     = [maxval*0.8 maxval];     
        end
        
     
        % plot
        cfg.title = (['AllConds_HF: ' num2str(i_HF) '(maskval ' num2str(maxval*0.8) ')']);
        ft_sourceplot(cfg,source_intp);
        view([1 0 0])
        lighting gouraud
       %  colorbar off
       
%%   
     print('-dpdf',[PicDir filesep 'CombMod_SOURCE_HF: '...
         num2str(i_HF) '_condAVG_left_med.pdf']); % _9HZpeak
    



%% condition difference

    diffconds = [1 3];
    i_HF = 1; 
    
        tmpact1 = squeeze(nanmean(avgB_MAT(:,diffconds(1),i_HF,:,t(1):t(2)),1));
        tmpact2 = squeeze(nanmean(avgB_MAT(:,diffconds(2),i_HF,:,t(1):t(2)),1));
        activation = squeeze(mean((tmpact1 - tmpact2),2));
        
     
        clear dummy_source
        dummy_source=commonfilter_tlock;
        dummy_source.avg.pow(dummy_source.inside) = activation;
        dummy_source.time= 0;
        
        % interpolate sources
        cfg              = [];
        cfg.parameter    = 'avg.pow';
        cfg.interpmethod = 'linear';
        source_intp = ft_sourceinterpolate(cfg, dummy_source, mri);
        
        cfg              = [];
        cfg.method       = 'surface' % 'ortho'; % 
        cfg.funparameter = 'pow';
        cfg.funcolormap    = 'parula';
        cfg.opacitymap     = 'rampup'; % use ramp-up if you plot positivities, rampdown for negativities
        cfg.projmethod     = 'nearest';
        cfg.renderer='opengl';
        cfg.sphereradius = 80;
        cfg.maskparameter  = cfg.funparameter;
        % cfg.funcolorlim = [-0.005 0.005];%
        cfg.surfdownsample = 0;
        % cfg.opacitylim =  [-0.0005 -0.001];% [0.001 0.01]; %
        cfg.camlight='no';
        

         cfg.surffile = 'surface_white_both.mat';
       % cfg.surffile = 'surface_white_left.mat';
       % cfg.surffile = 'surface_white_right.mat';
        
       % More beratiful but Mac-only:
        % cfg.surfinflated = 'surface_wminf_both.mat';

        
        cfg.atlas = ft_read_atlas('/Users/sophie/ownCloud/MATLAB_Toolboxes/fieldtrip-20170501/template/atlas/aal/ROI_MNI_V4.nii');
        
        cfg.title = (['CONDdiff: ' num2str(diffconds(1)) '-' num2str(diffconds(2)) '_HF: ' num2str(i_HF) ]);
        
        ft_sourceplot(cfg,source_intp);
        
        % lateral view
       %  view([1 0 0])
        
        % medial view
       %  view([-1 0 0])
        
       % from top
        view([0 0 1])
        
        lighting gouraud
        
        % colorbar off

%         print('-dpdf',[PicDir filesep 'SOURCE_' ...,
%             'CONDdiff: ' num2str(diffconds(1)) '-' num2str(diffconds(2)), ...
%             '_HF: ' num2str(i_HF) 'both.pdf']);
        
       


%% extract data from label

cfg = [];
cfg.atlas = ft_read_atlas('/Users/sophie/ownCloud/MATLAB_Toolboxes/fieldtrip-20170501/template/atlas/aal/ROI_MNI_V4.nii');
cfg.inputcoord = 'mni';
cfg.roi        = {'Supp_Motor_Area_L','Supp_Motor_Area_R'};

clear dummy_source
dummy_source=commonfilter_tlock;
dummy_source.avg.pow(dummy_source.inside) = activation;
dummy_source.time= 0;

mask = ft_volumelookup(cfg, dummy_source);

tmpdat = reshape(dummy_source.avg.pow,size(mask));

maskdat = tmpdat.*mask;
maskdat(find(maskdat==0)) = NaN;

meandat = nanmean(nanmean(nanmean(maskdat)));