# run RAnalysis first

currwd <- getwd()
wd <- paste0("/Users/Sophie/ownCloud/PROJECT_DisTime/ALL_DisTime_DATA/")
setwd(wd)

plotdir <- paste0("/Users/sophie/ownCloud/PROJECT_DisTime/DisTime_mTRF/MS_DisTime_TRF/Pics_MS_DisTime_TRF/ROutput/")


file <- paste0(wd, "/", "HF4R_EEGII.txt")
HF_Table <- read.table(file, header = TRUE)
# names(HF_Table)<-c('times_1','HF_1','times_2','HF_2','times_3','HF_3')

# for HF 2 and 3  we need to replace 0s (due to FPs that did not occur in cond 2 by the preceeding value)
for (i in 2:nrow(HF_Table)){
  if (HF_Table[i,4] == 0) {
    HF_Table[i,4] <- HF_Table[i-1,4]
  }
}

for (i in 2:nrow(HF_Table)){
  if (HF_Table[i,6] == 0) {
    HF_Table[i,6] <- HF_Table[i-1,6]
  }
}

# # # substract monotonic HF to obtain peak only
# HF_Table[,4] <- HF_Table[,4] - HF_Table[,2]
# HF_Table[,6] <- HF_Table[,6] - HF_Table[,2]
# 
# # remove negative values
# ix <- which(HF_Table<=0,arr.ind=TRUE)
# HF_Table[ix] <- 0

# add value of hazard function at tone onset to the data table
DATA$HF <- 0 # the true HF
DATA$HF1 <- 0 # always HF1
DATA$HF2 <- 0 # always HF2
DATA$HF3 <- 0 # always HF3

# define own round function that always rounds up .5 
round_up = function(x,n){
  posneg = sign(x)
  z = abs(x)*10^n
  z = z+0.5
  z = trunc(z)
  z = z/10^n
  z*posneg}

for (i in 1:nrow(DATA)){
  cond <- as.numeric(DATA$cond[i])
  FP<- round_up(DATA$FP[i],5) # needs to be rounded, otherwise the comparison doesn't work below
  #FP<- DATA$FP[i]
  col_ind <- cond + (cond-1)
    
  row_ind <- which(HF_Table[,col_ind] == FP)
  
  DATA$HF[i] <- HF_Table[row_ind,col_ind+1] # take the hazard value corresponding to the FP
  
  DATA$HF1[i] <- HF_Table[row_ind,2]
  DATA$HF2[i] <- HF_Table[row_ind,4] 
  DATA$HF3[i] <- HF_Table[row_ind,6] 
  
}

## center the HFs to the mean of HF
DATA$HFc <-  DATA$HF - mean(DATA$HF)
DATA$HF1c <- DATA$HF1 - mean(DATA$HF1)
DATA$HF2c <- DATA$HF2 - mean(DATA$HF2)
DATA$HF3c <- DATA$HF3 - mean(DATA$HF3)

DATA$HFs <- scale(DATA$HF)
DATA$HF1s <- scale(DATA$HF1)
DATA$HF2s <- scale(DATA$HF2)
DATA$HF3s <- scale(DATA$HF3)
  
## add the difference HF, 3-1
DATA$HF3m1 <- 0
DATA$HF3m1 <- DATA$HF3 - DATA$HF1
DATA$HF3m1[DATA$HF3m1 <0 ] <- 0
DATA$HF3m1c <- DATA$HF3m1 - mean(DATA$HF3m1)
DATA$HF3m1s <- scale(DATA$HF3m1) 

# check the hazard across FPs per cond

# true HF
HF_Plot<- ggplot(data=DATA, aes(x=FP, y=HFc, color = cond))  + # , fill = cond
  geom_line()+
  facet_grid(.~ cond)+
  theme_minimal()
HF_Plot
ggsave(paste0(plotdir, Exp , "FPxHF.pdf")) # _peakonly

# # true HF -- flipped coords
# HF_Plotyx<- ggplot(data=DATA, aes(x=FP, y=HF, color = cond))  + # , fill = cond
#   geom_line()+
#   facet_grid(.~ cond)+
#   coord_flip() 
# HF_Plotyx



# HF 1
HF1_Plot<- ggplot(data=DATA, aes(x=FP, y=HF1c, color = cond))  + # , fill = cond
   geom_line()+
  facet_grid(.~ cond)
HF1_Plot

# HF 2
HF2_Plot<- ggplot(data=DATA, aes(x=FP, y=HF2c, color = cond))  + # , fill = cond
  geom_line()+
  facet_grid(.~ cond)
HF2_Plot

# HF 3
HF3_Plot<- ggplot(data=DATA, aes(x=FP, y=HF3c, color = cond))  + # , fill = cond
  geom_line()+
  facet_grid(.~ cond)
HF3_Plot

# HF 3-1
HF3m1_Plot<- ggplot(data=DATA, aes(x=FP, y=HF3m1c, color = cond))  + # , fill = cond
  geom_line()+
  facet_grid(.~ cond)
HF3m1_Plot

RTxHF_Plot<- ggplot(data=DATA, aes(x=HF, y=logRT))  + # , fill = cond
  #(fun.data = "mean_cl_boot", conf.int=0.95, geom = "ribbon",alpha = 0.2, colour=NA)+
  stat_summary(fun.data = "mean_cl_boot", geom="point")+
  geom_point()
RTxHF_Plot


## log HF and bin
DATA$logHF <- log(DATA$HF)
breakslogHF <- seq(-5, 0, 0.5)
DATA$binlogHF <- .bincode(DATA$logHF,breakslogHF)

# linear bins, too
breaksHF <- seq(0, 1, 0.1)
DATA$binHF <- .bincode(DATA$HF,breaksHF)

# plot log HF
logHF_Plot<- ggplot(data=DATA, aes(x=FP, y=logHF, color = cond))  + # , fill = cond
  geom_line()+
  facet_grid(.~ cond)
logHF_Plot
ggsave(paste0(plotdir, Exp , "FPxlogHF.pdf"))


## binlogRT
breaksRT <- seq(6.6, 7, 0.01)
DATA$binlogRT <- .bincode(DATA$logRT,breaksRT)



# require("piecewiseSEM")
require('MuMIn') # for estimating R2 deals correctly with 2 random slopes

# https://jonlefcheck.net/2013/03/13/r2-for-linear-mixed-effects-models/
# http://mbjoseph.github.io/2013/08/22/r2.html
# marginal R: fixed factors
# conditional R: random & fixed

## MODELS
modDAT <- DATA

# NULL Model
LME0 <- lmer(formula = logRT ~ 1 + (1|sbname), data = modDAT) #REML = FALSE
cor(fitted(LME0), modDAT$logRT)^2

# add HF as fixed effect
LME1_HF <- lmer(formula = logRT ~ HFc + (HFc|sbname), data = modDAT)
anova(LME0,LME1_HF)
cor(fitted(LME1_HF), modDAT$logRT)^2
anova(LME1_HF)
summary(LME1_HF)
# sem.model.fits(LME1_HF)
r.squaredGLMM(LME1_HF)


# add HF as fixed effect
LME1_HF13 <- lmer(formula = logRT ~ HF1 * HF3 + (1|sbname), data = modDAT)
cor(fitted(LME1_HF13), modDAT$logRT)^2
anova(LME0,LME1_HF)
anova(LME1_HF13)

LME1_HF13_condfac <- lmer(formula = logRT ~ HF1 + HF3  + (1|sbname) + (HF1+HF3|cond) , data = modDAT)
cor(fitted(LME1_HF13_condfac), modDAT$logRT)^2
anova(LME1_HF13_condfac)

# get marginal and conditional R^2
sem.model.fits(list(LME0,LME1_HF,LME1_HF13,LME1_HF13_condfac))


## conditions separately
condDAT <- DATA[DATA$cond == 1,]

# random intercept
LME0_cond <- lmer(formula = logRT ~ 1 + (1|sbname), data = condDAT, REML = FALSE) # REML = FALSE
cor(fitted(LME0_cond ), condDAT$logRT)^2

# add HF1,3 as fixed effect
LME1_HF1_cond <- lmer(formula = logRT ~ HF1c  + (1|sbname), data = condDAT, REML = FALSE)

LME1_HF3m1_cond <- lmer(formula = logRT ~ HF3m1c  + (1|sbname), data = condDAT, REML = FALSE)

LME1_HF13m1_cond_add <- lmer(formula = logRT ~  HF1c + HF3m1c  + (1|sbname), data = condDAT, REML = FALSE)
LME1_HF13m1_cond_mult <- lmer(formula = logRT ~   HF3m1c * HF1c  + (1|sbname), data = condDAT, REML = FALSE)
anova(LME1_HF13m1_cond_add,LME1_HF13m1_cond_mult)
anova(LME1_HF13m1_cond_add)
anova(LME1_HF13m1_cond_mult)

anova(LME1_HF3m1_cond)

require('effects')
plot(effect("HF1c",LME1_HF13m1_cond_mult),multiline = TRUE) 
plot(effect("HF3m1c",LME1_HF13m1_cond_mult),multiline = TRUE) 
plot(effect("HF3c:HF1c",LME1_HF13m1_cond_mult),multiline = TRUE,x.var="HF3c") 

summary(LME1_HF13m1_cond_mult)

sem.model.fits(list(LME1_HF13_cond))
sem.model.fits(list(LME1_HF13m1_cond))

##############################################################
##############################################################
#### PLOTS
RTxHF_Plot<- ggplot(data=DATA, aes(x=logHF, y=logRT, group = cond, color = cond))  + # , fill = cond
  #(fun.data = "mean_cl_boot", conf.int=0.95, geom = "ribbon",alpha = 0.2, colour=NA)+
 #  stat_summary(fun.data = "mean_cl_boot", geom="point") +
  stat_summary(fun.data = "mean_cl_boot", geom="point") +
  stat_summary(fun.data = "mean_cl_boot", geom="line")
  # ylim(6.6, 6.95) 
RTxHF_Plot
ggsave(paste0(plotdir, Exp , "_logHFxlogHP.pdf"))

##############################################################
## plot RT x HF
##############################################################
# sumDATA_HF <- summarySEwithin(DATA, measurevar="logRT", withinvars=c("cond","logHF"),
 #                             idvar="sbname", na.rm=FALSE, conf.interval=.95)

require("ggthemes")

rm(sumDATA_HF)
library(plyr)
sumDATA_HF <- ddply(DATA, c("cond", "logHF"), summarise,
                    N    = length(logRT),
                    mean = mean(logRT),
                    sd   = sd(logRT),
                    se   = sd / sqrt(N)
)
sumDATA_HF
sumDATA_HF <- plyr::rename(sumDATA_HF, c("mean" = "logRT"))

sumDATA_HF


# se = standard error of the mean
eb <- aes(ymin=logRT-se, ymax=logRT+se)

# pdf(file = paste0(plotdir, Exp , "_logRTxFPbinxcond.pdf"))
PHF1<-  
  ggplot(data = sumDATA_HF, aes(x=logHF, y=logRT, group=cond, color = cond, fill = cond))  + # , fill = cond
  geom_line() + geom_point() +
  # geom_errorbar(width=.1, aes(ymin=logRT-se, ymax=logRT+se)) 
  geom_ribbon(eb, alpha = 0.5) +
  ylim(6.5, 7) +
  ggtitle(Exp) +
  theme_minimal()
PHF1
#dev.off() to use this with ggplot, print() has to be added around the plot command
ggsave(paste0(plotdir, Exp , "_logRTxlogHFxcond.pdf"))

##############################################################
## plot RT x HF by flipping coords
##############################################################

rm(sumDATA_HF)
library(plyr)
sumDATA_HF <- ddply(DATA, c("cond", "logHF"), summarise,
                    N    = length(logRT),
                    mean = mean(logRT),
                    sd   = sd(logRT),
                    se   = sd / sqrt(N)
)
sumDATA_HF
sumDATA_HF <- plyr::rename(sumDATA_HF, c("mean" = "logRT"))

sumDATA_HF


# se = standard error of the mean
eb <- aes(ymin=logRT-se, ymax=logRT+se)

# pdf(file = paste0(plotdir, Exp , "_logRTxFPbinxcond.pdf"))
PHF1<-  
  ggplot(data = sumDATA_HF, aes(x=logHF, y=logRT, group=cond, color = cond, fill = cond))  + # , fill = cond
  geom_line() + geom_point() +
  # geom_errorbar(width=.1, aes(ymin=logRT-se, ymax=logRT+se)) 
  geom_ribbon(eb, alpha = 0.5) +
  coord_flip() +
  scale_x_reverse()+
  # ylim(6.5, 7) +
  ggtitle(Exp)
PHF1
#dev.off() to use this with ggplot, print() has to be added around the plot command
ggsave(paste0(plotdir, Exp , "_logRTxlogHFxcond_reversed.pdf"))



##############################################################
## plot RT x FP
##############################################################
sumDATA_FP <- summarySEwithin(DATA, measurevar="logRT", withinvars=c("cond","FP"),
                              idvar="sbname", na.rm=FALSE, conf.interval=.95)
sumDATA_FP

# se = standard error of the mean
eb <- aes(ymin=logRT-se, ymax=logRT+se)

# pdf(file = paste0(plotdir, Exp , "_logRTxFPbinxcond.pdf"))
PFP1<-  
  ggplot(data = sumDATA_FP, aes(x=FP, y=logRT, group=cond, color = cond, fill = cond))  + # , fill = cond
  geom_line() + geom_point() +
  # geom_errorbar(width=.1, aes(ymin=logRT-se, ymax=logRT+se)) 
  geom_ribbon(eb, alpha = 0.5) +
  # ylim(6.5, 7) +
  ggplot(data = sumDATA_HF, aes(x=FP, y=HF, group=cond, color = cond, fill = cond))  + # , fill = cond
  geom_line() + 
  geom_point() +
  ggtitle(Exp)
PFP1
#dev.off() to use this with ggplot, print() has to be added around the plot command
ggsave(paste0(plotdir, Exp , "_logRTxFPxcond.pdf"))

##############################################################
## plot FP x HF
##############################################################
sumDATA_FPHF <- summarySEwithin(DATA, measurevar="HF", withinvars=c("cond","FP"),
                                idvar="sbname", na.rm=FALSE, conf.interval=.95)
sumDATA_FPHF

# se = standard error of the mean
eb <- aes(ymin=logRT-se, ymax=logRT+se)

# pdf(file = paste0(plotdir, Exp , "_logRTxFPbinxcond.pdf"))
PFPHF<-  
  ggplot(data = sumDATA_FPHF, aes(x=FP, y=HF, group=cond, color = cond, fill = cond))  + # , fill = cond
  geom_line() + geom_point() +
  ggtitle(Exp)
PFPHF
#dev.off() to use this with ggplot, print() has to be added around the plot command
ggsave(paste0(plotdir, Exp , "_logRTxFPxcond.pdf"))

## plot Interaction between HFs
require('pracma')
breaksHF1 <-  log10(logspace(-.1, .9, 20)) # seq(-.1, .9, .5) #
DATA$HF1c_bin <- .bincode(DATA$HF1c, breaksHF1)
DATA$HF1c_bin <- as.factor(DATA$HF1c_bin)

breaksHF2 <- seq(-.5, .5, 0.2)
DATA$HF2c_bin <- .bincode(DATA$HF2c, breaksHF2)
DATA$HF2c_bin <- as.factor(DATA$HF2c_bin)

breaksHF3m1 <- seq(-.4, .6, 0.2)
DATA$HF3c_bin <- .bincode(DATA$HF3m1c, breaksHF3m1)
DATA$HF3c_bin <- as.factor(DATA$HF3c_bin)

condDAT <- DATA[DATA$cond == 2,]
IA_Plot<- ggplot(data=condDAT, aes(x=HF3m1, y=logRT, color = HF1c_bin))  + # , fill = cond
  geom_point()+
  facet_grid(.~ HF1c_bin)
IA_Plot

hist(DATA$HF1c)
